go
set nocount on
go
drop view qryCustomers
go
create view qryCustomers
as
SELECT 'Cust' + [CustomerID] AS ID
    , 'None' AS parentID
    , [CustomerID] + ' ' + [CompanyName] AS nodeText
    , 'Cust' AS identifier
FROM Customers;
go
select * from qryCustomers
go
drop view qryE2E
go
create view qryE2E
as
SELECT 'E2E' + cast([E2E_ID] as varchar) AS ID
, 'E2E' + isnull(cast([Parent_ID] as Varchar),'')  AS parentID
, isnull([t_E2E].[Level_ID],'') + ': ' + isnull([Category_Descr],'') AS nodeText
, 'E2E' AS identifier
, t_E2E.Sort
FROM t_E2E;

go 
select * from qryE2E ORDER BY Sort
go

drop view qryE2ESort
go
create view qryE2ESort
as
SELECT t_E2E.E2E_ID          as E2E_ID
     , t_E2E.Level_ID        as Level_ID   
	 , t_E2E.Parent_ID       as Parent_ID
	 , t_E2E.Sort            as Sort
	 , isnull(t_E2E.Path,'') as Path
	 , t_E2E.Level           as Level
FROM t_E2E;
go
select * from qryE2ESort ORDER BY Sort
go
drop view qryEmployees
go
create view qryEmployees
as
SELECT 'Emp' + Cast(EmployeeID as Varchar) AS ID
     , 'Emp' + isnull(cast(ReportsTo as varchar),'') AS parentID
	 , FirstName + ' ' + LastName AS nodeText
	 , 'Emp' AS identifier
FROM Employees;
go
select * from qryEmployees
go
drop view qryOrderDetails
go
create view qryOrderDetails
as
SELECT 'OD'       + cast(OrderDetails.OrderID as varchar)
      + 'Product' + cast(Products.ProductID as varchar)      AS ID
      , 'Ord'     + cast(OrderDetails.OrderID as varchar)    AS parentID
	  , Products.ProductName + ' ' 
	              + cast(OrderDetails.Quantity as varchar)   AS nodeText
	  , 'OD' AS identifier
FROM Products LEFT JOIN OrderDetails ON Products.ProductID = OrderDetails.ProductID
go
select * from qryOrderDetails 

go
drop view qryOrders
go
create view qryOrders
as
SELECT 'Ord'     + cast(Orders.OrderID as varchar)     AS ID
     , 'Cust'    + cast(Orders.CustomerID as varchar)  AS parentID
     , 'Order: ' + cast(Orders.OrderID as varchar)   
	 + '   Date: ' 
	 + Convert(varchar(10),Orders.OrderDate,101)       AS nodeText
     , 'Ord' AS identifier
FROM Customers 
INNER JOIN Orders ON Customers.CustomerID = Orders.CustomerID
go
select * from qryOrders
go
drop view qryOutput
go
create view qryOutput
as
SELECT t_E2E.E2E_ID
     , isnull(t_E2E.Category_Descr,'') as Category_Descr
	 , isnull(t_E2E.Level_ID,'')       as Level_ID
	 , isnull(t_E2E.Parent_ID,'')      as Parent_ID
	 , t_E2E.ID_Type                   as ID_Type
	 , t_E2E.Sort                      as Sort  
	 , isnull(t_E2E.Path,'')           as Path
	 , t_E2E.Level                     as Level
FROM t_E2E;
go
select * from qryOutput ORDER BY Sort, Path
go
drop view qryCustomers_Orders_OrderDetails
go
create view qryCustomers_Orders_OrderDetails
as
Select * from qryCustomers  UNION select * from qryOrders UNION Select * from qryOrderDetails;
go
select * from qryCustomers_Orders_OrderDetails